Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDataObject.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDataObject.cpp	(revision 63103)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDataObject.cpp	(revision 63104)
@@ -208,5 +208,5 @@
         LogFlowFunc(("Waiting for event ...\n"));
         int rc2 = RTSemEventWait(mSemEvent, RT_INDEFINITE_WAIT);
-        LogFlowFunc(("rc=%Rrc, mStatus=%ld\n", rc2, mStatus));
+        LogFlowFunc(("rc2=%Rrc, mStatus=%ld\n", rc2, mStatus)); NOREF(rc2);
     }
 
@@ -441,4 +441,5 @@
 STDMETHODIMP VBoxDnDDataObject::GetDataHere(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium)
 {
+    RT_NOREF(pFormatEtc, pMedium);
     LogFlowFunc(("\n"));
     return DATA_E_FORMATETC;
@@ -458,6 +459,7 @@
 }
 
-STDMETHODIMP VBoxDnDDataObject::GetCanonicalFormatEtc(LPFORMATETC pFormatEct, LPFORMATETC pFormatEtcOut)
-{
+STDMETHODIMP VBoxDnDDataObject::GetCanonicalFormatEtc(LPFORMATETC pFormatEtc, LPFORMATETC pFormatEtcOut)
+{
+    RT_NOREF(pFormatEtc);
     LogFlowFunc(("\n"));
 
@@ -467,6 +469,7 @@
 }
 
-STDMETHODIMP VBoxDnDDataObject::SetData(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium,  BOOL fRelease)
-{
+STDMETHODIMP VBoxDnDDataObject::SetData(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium, BOOL fRelease)
+{
+    RT_NOREF(pFormatEtc, pMedium, fRelease);
     return E_NOTIMPL;
 }
@@ -474,12 +477,9 @@
 STDMETHODIMP VBoxDnDDataObject::EnumFormatEtc(DWORD dwDirection, IEnumFORMATETC **ppEnumFormatEtc)
 {
-    LogFlowFunc(("dwDirection=%RI32, mcFormats=%RI32, mpFormatEtc=%p\n",
-                 dwDirection, mcFormats, mpFormatEtc));
+    LogFlowFunc(("dwDirection=%RI32, mcFormats=%RI32, mpFormatEtc=%p\n", dwDirection, mcFormats, mpFormatEtc));
 
     HRESULT hr;
     if (dwDirection == DATADIR_GET)
-    {
         hr = VBoxDnDEnumFormatEtc::CreateEnumFormatEtc(mcFormats, mpFormatEtc, ppEnumFormatEtc);
-    }
     else
         hr = E_NOTIMPL;
@@ -489,6 +489,7 @@
 }
 
-STDMETHODIMP VBoxDnDDataObject::DAdvise(LPFORMATETC pFormatEtc, DWORD advf, IAdviseSink *pAdvSink, DWORD *pdwConnection)
-{
+STDMETHODIMP VBoxDnDDataObject::DAdvise(LPFORMATETC pFormatEtc, DWORD fAdvise, IAdviseSink *pAdvSink, DWORD *pdwConnection)
+{
+    RT_NOREF(pFormatEtc, fAdvise, pAdvSink, pdwConnection);
     return OLE_E_ADVISENOTSUPPORTED;
 }
@@ -496,4 +497,5 @@
 STDMETHODIMP VBoxDnDDataObject::DUnadvise(DWORD dwConnection)
 {
+    RT_NOREF(dwConnection);
     return OLE_E_ADVISENOTSUPPORTED;
 }
@@ -501,4 +503,5 @@
 STDMETHODIMP VBoxDnDDataObject::EnumDAdvise(IEnumSTATDATA **ppEnumAdvise)
 {
+    RT_NOREF(ppEnumAdvise);
     return OLE_E_ADVISENOTSUPPORTED;
 }
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDropTarget.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDropTarget.cpp	(revision 63103)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDropTarget.cpp	(revision 63104)
@@ -43,5 +43,5 @@
 {
     int rc = RTSemEventCreate(&hEventDrop);
-    LogFlowFunc(("rc=%Rrc\n", rc));
+    LogFlowFunc(("rc=%Rrc\n", rc)); NOREF(rc);
 }
 
@@ -129,7 +129,7 @@
  */
 
-STDMETHODIMP VBoxDnDDropTarget::DragEnter(IDataObject *pDataObject, DWORD grfKeyState,
-                                          POINTL pt, DWORD *pdwEffect)
-{
+STDMETHODIMP VBoxDnDDropTarget::DragEnter(IDataObject *pDataObject, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect)
+{
+    RT_NOREF(pt);
     AssertPtrReturn(pDataObject, E_INVALIDARG);
     AssertPtrReturn(pdwEffect, E_INVALIDARG);
@@ -229,4 +229,5 @@
 STDMETHODIMP VBoxDnDDropTarget::DragOver(DWORD grfKeyState, POINTL pt, DWORD *pdwEffect)
 {
+    RT_NOREF(pt);
     AssertPtrReturn(pdwEffect, E_INVALIDARG);
 
@@ -265,7 +266,7 @@
 }
 
-STDMETHODIMP VBoxDnDDropTarget::Drop(IDataObject *pDataObject,
-                                     DWORD grfKeyState, POINTL pt, DWORD *pdwEffect)
-{
+STDMETHODIMP VBoxDnDDropTarget::Drop(IDataObject *pDataObject, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect)
+{
+    RT_NOREF(pt);
     AssertPtrReturn(pDataObject, E_INVALIDARG);
     AssertPtrReturn(pdwEffect,   E_INVALIDARG);
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxLA.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxLA.cpp	(revision 63103)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxLA.cpp	(revision 63104)
@@ -911,12 +911,13 @@
     int l;
 
-    char **pClientInfoMap[LA_UTCINFO_CLIENT_INFO_LAST + 1] = {
-                                                               &pCtx->activeClient.pszPropName,
-                                                               &pCtx->activeClient.pszPropIPAddr,
-                                                               &pCtx->activeClient.pszPropLocation,
-                                                               &pCtx->activeClient.pszPropOtherInfo,
-                                                             };
-
-    pCtx->activeClient.u32LastAttach = ~0;
+    char **pClientInfoMap[LA_UTCINFO_CLIENT_INFO_LAST + 1] =
+    {
+        &pCtx->activeClient.pszPropName,
+        &pCtx->activeClient.pszPropIPAddr,
+        &pCtx->activeClient.pszPropLocation,
+        &pCtx->activeClient.pszPropOtherInfo,
+    };
+
+    pCtx->activeClient.u32LastAttach = UINT32_MAX;
     pCtx->activeClient.u64LastAttachTimestamp = u64ActiveClientTS;
 
@@ -1083,5 +1084,5 @@
 
     uint64_t u64Timestamp = 0;
-    uint32_t u32Attach = ~0;
+    uint32_t u32Attach = UINT32_MAX;
 
     int rc = laGetUint32(pCtx->u32GuestPropHandle,