Index: trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-win.cpp
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-win.cpp	(revision 62956)
+++ trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-win.cpp	(revision 63134)
@@ -405,4 +405,5 @@
 static uint32_t vmsvga3dGetDepthFormatSupport(PVMSVGA3DSTATE pState3D, uint32_t idx3dCaps, D3DFORMAT format)
 {
+    RT_NOREF(idx3dCaps);
     HRESULT  hr;
     uint32_t result = 0;
@@ -1060,4 +1061,8 @@
         /* Unknown; only in DX10 & 11 */
         break;
+
+    case SVGA3D_FORMAT_MAX:     /* shut up MSC */
+    case SVGA3D_FORMAT_INVALID:
+        break;
     }
     AssertFailedReturn(D3DFMT_UNKNOWN);
@@ -1088,4 +1093,5 @@
 void vmsvga3dBackSurfaceDestroy(PVMSVGA3DSTATE pState, PVMSVGA3DSURFACE pSurface)
 {
+    RT_NOREF(pState);
     RTAvlU32Destroy(&pSurface->pSharedObjectTree, vmsvga3dSharedSurfaceDestroyTree, pSurface);
     Assert(pSurface->pSharedObjectTree == NULL);
@@ -1164,4 +1170,5 @@
 static PVMSVGA3DSHAREDSURFACE vmsvga3dSurfaceGetSharedCopy(PVGASTATE pThis, PVMSVGA3DCONTEXT pContext, PVMSVGA3DSURFACE pSurface)
 {
+    RT_NOREF(pThis);
     Assert(pSurface->hSharedObject);
 
@@ -1205,4 +1212,5 @@
 static int vmsvga3dSurfaceTrackUsage(PVMSVGA3DSTATE pState, PVMSVGA3DCONTEXT pContext, PVMSVGA3DSURFACE pSurface)
 {
+    RT_NOREF(pState);
 #ifndef VBOX_VMSVGA3D_WITH_WINE_OPENGL
     Assert(pSurface->id != SVGA3D_INVALID_ID);
@@ -1254,4 +1262,5 @@
 int vmsvga3dSurfaceFlush(PVGASTATE pThis, PVMSVGA3DSURFACE pSurface)
 {
+    RT_NOREF(pThis);
 #ifndef VBOX_VMSVGA3D_WITH_WINE_OPENGL
     HRESULT hr;
@@ -1542,4 +1551,5 @@
 
 {
+    RT_NOREF(pState);
     HRESULT hr;
     IDirect3DTexture9 *pTexture;
@@ -2143,5 +2153,4 @@
     PVMSVGA3DSTATE      pState = pThis->svga.p3dState;
     PVMSVGA3DSURFACE    pSurface;
-    int                 rc = VINF_SUCCESS;
     PVMSVGA3DCONTEXT    pContext;
     uint32_t            cid;
@@ -3052,5 +3061,5 @@
 int vmsvga3dSetRenderState(PVGASTATE pThis, uint32_t cid, uint32_t cRenderStates, SVGA3dRenderState *pRenderState)
 {
-    DWORD                       val;
+    DWORD                       val = 0; /* Shut up MSC */
     HRESULT                     hr;
     PVMSVGA3DCONTEXT            pContext;
@@ -3710,4 +3719,8 @@
             */
             break;
+
+        case SVGA3D_RS_MAX:                   /* shut up MSC */
+        case SVGA3D_RS_INVALID:
+            AssertFailedBreak();
         }
 
@@ -4155,5 +4168,5 @@
 int vmsvga3dSetTextureState(PVGASTATE pThis, uint32_t cid, uint32_t cTextureStates, SVGA3dTextureState *pTextureState)
 {
-    DWORD                       val;
+    DWORD                       val = 0; /* Shut up MSC */
     HRESULT                     hr;
     PVMSVGA3DCONTEXT            pContext;
@@ -4404,4 +4417,8 @@
             AssertFailed();
             break;
+
+        case SVGA3D_TS_MAX:                   /* shut up MSC */
+        case SVGA3D_TS_INVALID:
+            AssertFailedBreak();
         }
 
@@ -4853,8 +4870,9 @@
                            uint32_t cVertexDivisor, SVGA3dVertexDivisor *pVertexDivisor)
 {
+    RT_NOREF(pVertexDivisor);
     PVMSVGA3DCONTEXT             pContext;
     PVMSVGA3DSTATE               pState = pThis->svga.p3dState;
     AssertReturn(pState, VERR_INTERNAL_ERROR);
-    int                          rc;
+    int                          rc = VINF_SUCCESS;
     HRESULT                      hr;
     uint32_t                     iCurrentVertex, iCurrentStreamId;
@@ -5485,4 +5503,5 @@
 int vmsvga3dQueryBegin(PVGASTATE pThis, uint32_t cid, SVGA3dQueryType type)
 {
+    RT_NOREF(pThis, cid, type);
     AssertFailed();
     return VERR_NOT_IMPLEMENTED;
@@ -5491,4 +5510,5 @@
 int vmsvga3dQueryEnd(PVGASTATE pThis, uint32_t cid, SVGA3dQueryType type, SVGAGuestPtr guestResult)
 {
+    RT_NOREF(pThis, cid, type, guestResult);
     AssertFailed();
     return VERR_NOT_IMPLEMENTED;
@@ -5497,4 +5517,5 @@
 int vmsvga3dQueryWait(PVGASTATE pThis, uint32_t cid, SVGA3dQueryType type, SVGAGuestPtr guestResult)
 {
+    RT_NOREF(pThis, cid, type, guestResult);
     AssertFailed();
     return VERR_NOT_IMPLEMENTED;