Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 63315)
@@ -43,4 +43,6 @@
 {
 public:
+    virtual ~CheckIfSuitableBy() { /* Makes MSC happy. */ }
+
     /** Determines whether passed @a pItem is suitable. */
     virtual bool isItSuitable(UIMediumItem *pItem) const = 0;
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/win/VBoxUtils-win.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/win/VBoxUtils-win.h	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/win/VBoxUtils-win.h	(revision 63315)
@@ -16,6 +16,6 @@
  */
 
-#ifndef __VBoxUtils_WIN_h__
-#define __VBoxUtils_WIN_h__
+#ifndef ___VBoxUtils_WIN_h___
+#define ___VBoxUtils_WIN_h___
 
 /* Qt includes: */
@@ -23,5 +23,5 @@
 
 /* Platform includes: */
-#include "Windows.h"
+#include <iprt/win/windows.h>
 
 /* Namespace for native window sub-system functions: */
@@ -32,4 +32,4 @@
 }
 
-#endif /* __VBoxUtils_WIN_h__ */
+#endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/win/WinKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/win/WinKeyboard.cpp	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/win/WinKeyboard.cpp	(revision 63315)
@@ -192,7 +192,7 @@
 static bool doesCurrentLayoutHaveAltGr()
 {
-    /** Keyboard state array with VK_CONTROL and VK_MENU depressed. */
-    const BYTE auKeyStates[256] =
-        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x80, 0x80 };
+    /* Keyboard state array with VK_CONTROL and VK_MENU depressed. */
+    static const BYTE s_auKeyStates[256] =
+    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x80, 0x80 };
     WORD ach;
     unsigned i;
@@ -200,5 +200,5 @@
     for (i = '0'; i <= VK_OEM_102; ++i)
     {
-        if (ToAscii(i, 0, auKeyStates, &ach, 0))
+        if (ToAscii(i, 0, s_auKeyStates, &ach, 0))
             break;
         /* Skip ranges of virtual keys which are undefined or not relevant. */
@@ -269,21 +269,23 @@
                                                    bool fExtendedKey) const
 {
+    if (iDownScanCode != 0x1d /* scan code: Control */ || fExtendedKey)
+        return false;
+
+    LONG messageTime = GetMessageTime();
     MSG peekMsg;
-    LONG messageTime = GetMessageTime();
-
-    if (   iDownScanCode != 0x1d /* scan code: Control */ || fExtendedKey)
-        return false;
     if (!PeekMessage(&peekMsg, NULL, WM_KEYFIRST, WM_KEYLAST, PM_NOREMOVE))
         return false;
-
-        if (messageTime != peekMsg.time)
-            return false;
-        if (   fKeyDown
-        && (peekMsg.message != WM_KEYDOWN && peekMsg.message != WM_SYSKEYDOWN))
+    if (messageTime != (LONG)peekMsg.time)
+        return false;
+
+    if (   fKeyDown
+        && peekMsg.message != WM_KEYDOWN
+        && peekMsg.message != WM_SYSKEYDOWN)
         return false;
     if (   !fKeyDown
-        && (peekMsg.message != WM_KEYUP && peekMsg.message != WM_SYSKEYUP))
-        return false;
-    if (   ((RT_HIWORD(peekMsg.lParam) & 0xFF) != 0x38 /* scan code: Alt */)
+        && peekMsg.message != WM_KEYUP
+        && peekMsg.message != WM_SYSKEYUP)
+        return false;
+    if (   (RT_HIWORD(peekMsg.lParam) & 0xFF) != 0x38 /* scan code: Alt */
         || !(RT_HIWORD(peekMsg.lParam) & KF_EXTENDED))
         return false;
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/win/WinKeyboard.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/win/WinKeyboard.h	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/win/WinKeyboard.h	(revision 63315)
@@ -16,9 +16,9 @@
  */
 
-#ifndef __WinKeyboard_h__
-#define __WinKeyboard_h__
+#ifndef ___WinKeyboard_h___
+#define ___WinKeyboard_h___
 
 /* Platform includes: */
-#include "Windows.h"
+#include <iprt/win/windows.h>
 
 void * WinHidDevicesKeepLedsState(void);
@@ -80,6 +80,7 @@
         FAKE_CONTROL_DOWN
     } m_enmFakeControlDetectionState;
-    DWORD m_timeOfLastKeyEvent;
+    LONG m_timeOfLastKeyEvent;
 };
-#endif /* __WinKeyboard_h__ */
 
+#endif
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 63315)
@@ -1387,4 +1387,5 @@
         case QEvent::GraphicsSceneDragLeave:
             return processDragLeaveEvent(static_cast<QGraphicsSceneDragDropEvent*>(pEvent));
+        default: break; /* Shut up MSC */
     }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDefs.h	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDefs.h	(revision 63315)
@@ -56,4 +56,6 @@
     /* Creates empty cache item: */
     UISettingsCache() { m_value = qMakePair(CacheData(), CacheData()); }
+
+    virtual ~UISettingsCache() { /* Makes MSC happy */ }
 
     /* Returns the NON-modifiable REFERENCE to the initial cached data: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupStack.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupStack.cpp	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupStack.cpp	(revision 63315)
@@ -271,4 +271,5 @@
             break;
         }
+        default: break; /* Shuts up MSC.  */
     }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/UIWizardPage.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/UIWizardPage.h	(revision 63314)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/UIWizardPage.h	(revision 63315)
@@ -16,6 +16,6 @@
  */
 
-#ifndef __UIWizardPage_h__
-#define __UIWizardPage_h__
+#ifndef ___UIWizardPage_h___
+#define ___UIWizardPage_h___
 
 /* Global includes: */
@@ -34,4 +34,7 @@
 class UIWizardPageBase
 {
+public:
+    virtual ~UIWizardPageBase() { /* Makes MSC happy. */ }
+
 protected:
 
@@ -74,4 +77,4 @@
 };
 
-#endif // __UIWizardPage_h__
+#endif
 