Index: trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp	(revision 63444)
+++ trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp	(revision 63445)
@@ -629,8 +629,12 @@
 }
 
-static DECLCALLBACK(OSStatus) drvHostCoreAudioDeviceStateChanged(AudioObjectID propertyID,
-                                                                 UInt32 nAddresses,
-                                                                 const AudioObjectPropertyAddress properties[],
-                                                                 void *pvUser)
+
+/**
+ * Implements the OS X callback AudioObjectPropertyListenerProc.
+ */
+static OSStatus drvHostCoreAudioDeviceStateChanged(AudioObjectID propertyID,
+                                                   UInt32 nAddresses,
+                                                   const AudioObjectPropertyAddress properties[],
+                                                   void *pvUser)
 {
     LogFlowFunc(("propertyID=%u nAddresses=%u pvUser=%p\n", propertyID, nAddresses, pvUser));
@@ -701,9 +705,13 @@
 }
 
-/* Callback for getting notified when the default recording/playback device has been changed. */
-static DECLCALLBACK(OSStatus) coreAudioDefaultDeviceChanged(AudioObjectID propertyID,
-                                                            UInt32 nAddresses,
-                                                            const AudioObjectPropertyAddress properties[],
-                                                            void *pvUser)
+
+/**
+ * Implements the OS X callback AudioObjectPropertyListenerProc for getting
+ * notified when the default recording/playback device has been changed.
+ */
+static OSStatus coreAudioDefaultDeviceChanged(AudioObjectID propertyID,
+                                              UInt32 nAddresses,
+                                              const AudioObjectPropertyAddress properties[],
+                                              void *pvUser)
 {
     OSStatus err = noErr;
@@ -791,9 +799,13 @@
 }
 
-/* Callback for getting notified when some of the properties of an audio device has changed. */
-static DECLCALLBACK(OSStatus) coreAudioRecordingAudioDevicePropertyChanged(AudioObjectID                     propertyID,
-                                                                           UInt32                            cAdresses,
-                                                                           const AudioObjectPropertyAddress  aProperties[],
-                                                                           void                             *pvUser)
+
+/**
+ * Implements the OS X callback AudioObjectPropertyListenerProc for getting
+ * notified when some of the properties of an audio device has changed.
+ */
+static OSStatus coreAudioRecordingAudioDevicePropertyChanged(AudioObjectID                     propertyID,
+                                                             UInt32                            cAdresses,
+                                                             const AudioObjectPropertyAddress  aProperties[],
+                                                             void                             *pvUser)
 {
     PCOREAUDIOSTREAMIN pStreamIn = (PCOREAUDIOSTREAMIN)pvUser;
@@ -826,10 +838,13 @@
 }
 
-/* Callback to convert audio input data from one format to another. */
-static DECLCALLBACK(OSStatus) coreAudioConverterCallback(AudioConverterRef              inAudioConverter,
-                                                         UInt32                        *ioNumberDataPackets,
-                                                         AudioBufferList               *ioData,
-                                                         AudioStreamPacketDescription **ppASPD,
-                                                         void                          *pvUser)
+/**
+ * Implements the OS X callback AudioConverterComplexInputDataProc for
+ * converting audio input data from one format to another.
+ */
+static OSStatus coreAudioConverterCallback(AudioConverterRef              inAudioConverter,
+                                           UInt32                        *ioNumberDataPackets,
+                                           AudioBufferList               *ioData,
+                                           AudioStreamPacketDescription **ppASPD,
+                                           void                          *pvUser)
 {
     AssertPtrReturn(ioNumberDataPackets, g_caConverterEOFDErr);
@@ -901,11 +916,14 @@
 }
 
-/* Callback to feed audio input buffer. */
-static DECLCALLBACK(OSStatus) coreAudioRecordingCb(void                       *pvUser,
-                                                   AudioUnitRenderActionFlags *pActionFlags,
-                                                   const AudioTimeStamp       *pAudioTS,
-                                                   UInt32                      uBusID,
-                                                   UInt32                      cFrames,
-                                                   AudioBufferList            *pBufData)
+/**
+ * Implements the OS X callback AURenderCallback in order to feed the audio
+ * input buffer.
+ */
+static OSStatus coreAudioRecordingCb(void                       *pvUser,
+                                     AudioUnitRenderActionFlags *pActionFlags,
+                                     const AudioTimeStamp       *pAudioTS,
+                                     UInt32                      uBusID,
+                                     UInt32                      cFrames,
+                                     AudioBufferList            *pBufData)
 {
     /* If nothing is pending return immediately. */
@@ -1870,9 +1888,13 @@
 }
 
-/* Callback for getting notified when some of the properties of an audio device has changed. */
-static DECLCALLBACK(OSStatus) coreAudioPlaybackAudioDevicePropertyChanged(AudioObjectID propertyID,
-                                                                          UInt32 nAddresses,
-                                                                          const AudioObjectPropertyAddress properties[],
-                                                                          void *pvUser)
+
+/**
+ * Implements the OS X callback AudioObjectPropertyListenerProc for getting
+ * notified when some of the properties of an audio device has changed.
+ */
+static OSStatus coreAudioPlaybackAudioDevicePropertyChanged(AudioObjectID propertyID,
+                                                            UInt32 nAddresses,
+                                                            const AudioObjectPropertyAddress properties[],
+                                                            void *pvUser)
 {
     switch (propertyID)
@@ -1887,11 +1909,15 @@
 }
 
-/* Callback to feed audio output buffer. */
-static DECLCALLBACK(OSStatus) coreAudioPlaybackCb(void *pvUser,
-                                                  AudioUnitRenderActionFlags *pActionFlags,
-                                                  const AudioTimeStamp       *pAudioTS,
-                                                  UInt32                      uBusID,
-                                                  UInt32                      cFrames,
-                                                  AudioBufferList            *pBufData)
+
+/**
+ * Implements the OS X callback AURenderCallback in order to feed the audio
+ * output buffer.
+ */
+static OSStatus coreAudioPlaybackCb(void *pvUser,
+                                    AudioUnitRenderActionFlags *pActionFlags,
+                                    const AudioTimeStamp       *pAudioTS,
+                                    UInt32                      uBusID,
+                                    UInt32                      cFrames,
+                                    AudioBufferList            *pBufData)
 {
     PCOREAUDIOSTREAMOUT pStreamOut  = (PCOREAUDIOSTREAMOUT)pvUser;
@@ -2168,6 +2194,5 @@
 }
 
-static DECLCALLBACK(int) coreAudioControlStreamOut(PDRVHOSTCOREAUDIO pThis,
-                                                   PPDMAUDIOSTREAM pStream, PDMAUDIOSTREAMCMD enmStreamCmd)
+static int coreAudioControlStreamOut(PDRVHOSTCOREAUDIO pThis, PPDMAUDIOSTREAM pStream, PDMAUDIOSTREAMCMD enmStreamCmd)
 {
     PCOREAUDIOSTREAMOUT pStreamOut = (PCOREAUDIOSTREAMOUT)pStream;